package app;

import java.util.ArrayList;
import java.util.List;

/**
 * Person
 */
public class Person {
    private String preName;
    private String lastName;
    private int age;
    private List<Hobbies> hobbies = new ArrayList<Hobbies>();

    public Person(String preName, String lastName, int age) {
        setPreName(preName);
        setLastName(lastName);
        setAge(age);
    }

    public String getPreName() {
        return this.preName;
    }

    public void setPreName(String preName) {
        if (preName.isEmpty())
            throw new IllegalArgumentException();
        this.preName = preName;
    }

    public String getLastName() {
        return this.lastName;
    }

    public void setLastName(String lastName) {
        if (lastName.isEmpty())
            throw new IllegalArgumentException();
        this.lastName = lastName;
    }

    public int getAge() {
        return this.age;
    }

    public void setAge(int age) {
        if (age < 0)
            throw new IllegalArgumentException();
        this.age = age;
    }

    public List<Hobbies> getHobbies() {
        return this.hobbies;
    }

    public void addHobby(Hobbies hobby) throws NoFreeTimeException {
        if (!hobbies.contains(hobby))
            if (hobbies.size() > 4)
                throw new NoFreeTimeException();
            else
                hobbies.add(hobby);
    }

    @Override
    public String toString() {
        return "{" + " preName='" + preName + "'" + ", lastName='" + lastName + "'" + ", age='" + age + "'"
                + ", hobbies='" + hobbies + "'" + "}";
    }

}